# Symbiote Manager Plugin

This unofficial TaleSpire mod allows users to download Symbiotes from Thunderstore using R2ModMan and then, with the
help of this plugin, enable or disable the Symbiotes at runtime.

!!! Warning: You need to update the one entry in the configuration before you can use this plugin !!!
 
## Change Log

```
1.0.0: Initial release
```
## Why Is It Needed?

R2ModMan is designed for use with plugins but not Symbiotes. When a user downloads a plugin, R2ModMan places the
content in a specific location where BepInEx can find it when Talespire is loaded. However, R2ModMan does not know
anything about Symbiotes and thus doesn't know the proper place to put them in order for Talespire to use them.

This is where the Symbiote Manager comes in. It finds all of the Symbiotes downloaded from Thunderstore with R2ModMan
and allows you, at runtime, to enable any of them using a GUI. When the Symbiote is enabled, the plugin copies the
contents to the Talespire Symbiote folder and it becomes available in Talespire. When a Symbiote is no longer needed,
the same GUI can be used to remove the Symbiote from the Talespire Symbiote folder thus removing from the available
Symbiotes in Talespire.

It should be noted that BR will eventually come out with their own hosting for Symbiotes which will not be Thunderstone
based. However, some users (expecially those with modded Talespire) may prefer to get their Symbiotes from Thunderstore
or, at least, get them from Thunderstore until the official BR alternative is available.

## Install

Use R2ModMan or similar installer to install.

After downloading, run Talespire from the command line to get Beta with Mods using something like:

``D:\Steam\steamapps\common\TaleSpire\TaleSpire.exe --doorstop-enable true 
--doorstop-target "C:\Users\%USERNAME%\AppData\Roaming\r2modmanPlus-local\TaleSpire\profiles\Default\BepInEx\core\BepInEx.Preloader.dll"``

Once Talespire main menu is reached. Shutdown Talespire. This needs to be done only once but if you don't do it things will not work.

Having started Talespire creates the default settings for the plugin. Go to R2ModMan and use the Edit Config to edit the configuration
for the plugin. There wil be a setting called ``Talespire Symbiote Folder``. The default setting is what BR indicated in their
Symbiote documentation but this seems to resolve to wrong place when executed by the plugin. Change this property to point to the
actual Symbiote folder without using the ``%AppData%`` shortcut. For example:

``C:\Users\%USERNAME%\AppData\LocalLow\BouncyRock Entertainment\TaleSpire\Symbiotes``

Save the changes. The plugin is now ready to be used.

## Usage

1. Download the desired Symbiotes from Thunderstore.
2. Start Talespire.
3. Open the Symbiote Manager (default ``RCTRL``+``S``).
4. Click the arrow button before any Symbiote on the left hand side (Downloaded Symbiotes) to enabled it.
5. Doing so will make the Symbiote appear on the left hand side (Installed Symbiotes).
6. Press the X button before a Symbiote on the left hand side to remove it from Talespire.
7. Press the Symbiote Manager keys again to close the manager.

Note: When a Symbiote is installed, it will show up in both lists since it is both downloaded and installed.
If the installation is then deleted via R2ModMan, the Symbiote will only shown in the Installed list.

Note: When a Symbiote is removed, it is not copied back to the downloaded area (if it has been removed from
the downloads). It is just a simple delete.

Note: Be careful with Symbiotes that were not added via R2ModMan/Thunderstore. These Symbiotes will still be
listed in the installed section but will not have a corresponding entry in the downloaded section and thus
if removed, there will be no way to put them back without re-downloading them manually.

## Creating Thunderstore Symbiote Packs Compatible With Symbiote Manager

1. Create a pack with the basic files (``icon.png``, ``license.txt``, ``manifest.json``, and ``Readme.md``) at the root in
the same manner as when making a pack for assetes or plugins.
2. Create a ``plugins`` folder. Yes, this is not a plugin but this allows the contents to be placed in the correct place.
3. Create a ``Symbiote`` folder within the ``plugins`` folder.
4. Place the symbiote files within the ``Symbiote`` folder. This must include the ``manifest.json`` file for the Symbiote
(not to be confused with the ``manifest.json`` for the pack which is at the root level) and any other Symbiote files needed.
5. Zip up the contents as usual. The pack is now ready.

## Versioning

The Symbiote Manager uses one or two versions depending on what is available. Thunderstone packs must always have a
verson_number property in the manifest and thus this version is always used. However, the Symbiote itself may have a version
although this is optional. If the Symbiote has a version, this version will also be displayed. In most cases these version
will likely be the same but it is possible, for example, to increase the pack version to correct documentation without
actually changing the Symbiote version.

## Skinnable Appearance And Alternate Theme

The appearance of the plugin is skinnable. It loads both the background and the buttons from texture files and the color
of the font is configurable in the plugin configuration. This means by replacing the textures and adjusting the color
you can create your own look for the plugin.

The default theme that comes with the plugin is a theme that mimics the Talespire colors. However, includes is a more funky
circuit board theme which you can switch to. Just rename the images files that don't include ``alt`` to something else
and rename the images with ``alt`` to remove the alt. It is recommended, for this theme, to switch the text color to
LightBlue (you can do this using the R2ModMan Edit Config option for this plugin).